
class AssertionError < RuntimeError
	def initialize(msg = "Help!")
		super(msg)
	end
end

def assert(msg, &block) raise AssertionError, msg unless yield end

class DhallError < StandardError
	def initialize(msg)
		super(msg)
	end
end

$dhallish_internal_global_counter = 0
def get_new_sym()
	$dhallish_internal_global_counter += 1
	("__newsym_#{$dhallish_internal_global_counter}").to_sym
end

def escape_str(str)
	str.gsub("\n", "\\n").gsub("\"", "\\\"")
end

def does_cmd_exist?(cmd)
	ENV['PATH'].split(File::PATH_SEPARATOR).each { |path|
		exe = File.join(path, cmd)
		if File.executable?(exe) && !File.directory?(exe)
			return true
		end
	}
	return false
end

def resolve_map(map, from_name, to_name)
	resmap = {}
	map.each { |key, val|
		reskey = key
		resval = val
		if reskey == from_name; reskey = to_name; end
		if resval == from_name; resval = to_name; end
		resmap[reskey] = resval
	}
	resmap
end
